#include <Indicators\Indicator.mqh>
#include <Arrays\ArrayDouble.mqh>

class CStochastic: public CIndicator
{
  private:
    int             m_KPeriod;
    int             m_DPeriod;
    int             m_Slowing;
    ENUM_APPLIED_PRICE m_AppliedPrice;
    ArrayDouble     m_K;
    ArrayDouble     m_D;
  public:
    CStochastic();
    void            SetKPeriod(const int KPeriod);
    void            SetDPeriod(const int DPeriod);
    void            SetSlowing(const int Slowing);
    void            SetAppliedPrice(const ENUM_APPLIED_PRICE AppliedPrice);
    ENUM_APPLIED_PRICE GetAppliedPrice() const;
    int             GetKPeriod() const;
    int             GetDPeriod() const;
    int             GetSlowing() const;
    void            OnCalculate(const int rates_total,
                                const int prev_calculated,
                                const datetime &time[],
                                const double &open[],
                                const double &high[],
                                const double &low[],
                                const double &close[],
                                const long &tick_volume[],
                                const long &volume[],
                                const int &spread[]);
    bool            IsValid() const;
};
